# **********************************************************************
#
# Copyright (c) 2003-2006 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************

# Ice version 3.1.1
# Generated from file `Observer.ice'

require 'Ice'
require 'Glacier2/Session.rb'
require 'IceGrid/Exception.rb'
require 'IceGrid/Descriptor.rb'
require 'IceGrid/Admin.rb'

module IceGrid

    if not defined?(::IceGrid::ServerDynamicInfo)
	class ServerDynamicInfo
	    def initialize(id='', state=::IceGrid::ServerState::Inactive, pid=0, enabled=false)
		@id = id
		@state = state
		@pid = pid
		@enabled = enabled
	    end

	    def hash
		_h = 0
		_h = 5 * _h + @id.hash
		_h = 5 * _h + @state.hash
		_h = 5 * _h + @pid.hash
		_h = 5 * _h + @enabled.hash
		_h % 0x7fffffff
	    end

	    def ==(other)
		return false if
		    @id != other.id or
		    @state != other.state or
		    @pid != other.pid or
		    @enabled != other.enabled
		true
	    end

	    def inspect
		::Ice::__stringify(self, T_ServerDynamicInfo)
	    end

	    attr_accessor :id, :state, :pid, :enabled
	end

	T_ServerDynamicInfo = ::Ice::__defineStruct('::IceGrid::ServerDynamicInfo', ServerDynamicInfo, [
	    ["id", ::Ice::T_string],
	    ["state", ::IceGrid::T_ServerState],
	    ["pid", ::Ice::T_int],
	    ["enabled", ::Ice::T_bool]
	])
    end

    if not defined?(::IceGrid::T_ServerDynamicInfoSeq)
	T_ServerDynamicInfoSeq = ::Ice::__defineSequence('::IceGrid::ServerDynamicInfoSeq', ::IceGrid::T_ServerDynamicInfo)
    end

    if not defined?(::IceGrid::AdapterDynamicInfo)
	class AdapterDynamicInfo
	    def initialize(id='', proxy=nil)
		@id = id
		@proxy = proxy
	    end

	    def hash
		_h = 0
		_h = 5 * _h + @id.hash
		_h = 5 * _h + @proxy.hash
		_h % 0x7fffffff
	    end

	    def ==(other)
		return false if
		    @id != other.id or
		    @proxy != other.proxy
		true
	    end

	    def inspect
		::Ice::__stringify(self, T_AdapterDynamicInfo)
	    end

	    attr_accessor :id, :proxy
	end

	T_AdapterDynamicInfo = ::Ice::__defineStruct('::IceGrid::AdapterDynamicInfo', AdapterDynamicInfo, [
	    ["id", ::Ice::T_string],
	    ["proxy", ::Ice::T_ObjectPrx]
	])
    end

    if not defined?(::IceGrid::T_AdapterDynamicInfoSeq)
	T_AdapterDynamicInfoSeq = ::Ice::__defineSequence('::IceGrid::AdapterDynamicInfoSeq', ::IceGrid::T_AdapterDynamicInfo)
    end

    if not defined?(::IceGrid::NodeDynamicInfo)
	class NodeDynamicInfo
	    def initialize(name='', info=::IceGrid::NodeInfo.new, servers=nil, adapters=nil)
		@name = name
		@info = info
		@servers = servers
		@adapters = adapters
	    end

	    def hash
		_h = 0
		_h = 5 * _h + @name.hash
		_h = 5 * _h + @info.hash
		_h = 5 * _h + @servers.hash
		_h = 5 * _h + @adapters.hash
		_h % 0x7fffffff
	    end

	    def ==(other)
		return false if
		    @name != other.name or
		    @info != other.info or
		    @servers != other.servers or
		    @adapters != other.adapters
		true
	    end

	    def inspect
		::Ice::__stringify(self, T_NodeDynamicInfo)
	    end

	    attr_accessor :name, :info, :servers, :adapters
	end

	T_NodeDynamicInfo = ::Ice::__defineStruct('::IceGrid::NodeDynamicInfo', NodeDynamicInfo, [
	    ["name", ::Ice::T_string],
	    ["info", ::IceGrid::T_NodeInfo],
	    ["servers", ::IceGrid::T_ServerDynamicInfoSeq],
	    ["adapters", ::IceGrid::T_AdapterDynamicInfoSeq]
	])
    end

    if not defined?(::IceGrid::T_NodeDynamicInfoSeq)
	T_NodeDynamicInfoSeq = ::Ice::__defineSequence('::IceGrid::NodeDynamicInfoSeq', ::IceGrid::T_NodeDynamicInfo)
    end

    if not defined?(::IceGrid::NodeObserver_mixin)
	module NodeObserver_mixin
	    include ::Ice::Object_mixin

	    def ice_ids(current=nil)
		['::Ice::Object', '::IceGrid::NodeObserver']
	    end

	    def ice_id(current=nil)
		'::IceGrid::NodeObserver'
	    end

	    #
	    # Operation signatures.
	    #
	    # def init(nodes, current=nil)
	    # def nodeUp(node, current=nil)
	    # def nodeDown(name, current=nil)
	    # def updateServer(node, updatedInfo, current=nil)
	    # def updateAdapter(node, updatedInfo, current=nil)

	    def inspect
		::Ice::__stringify(self, T_NodeObserver)
	    end
	end
	module NodeObserverPrx_mixin

	    def init(nodes, _ctx=nil)
		NodeObserver_mixin::OP_init.invoke(self, [nodes], _ctx)
	    end

	    def init_async(_cb, nodes, _ctx=nil)
		NodeObserver_mixin::OP_init.invokeAsync(self, _cb, [nodes, ], _ctx)
	    end

	    def nodeUp(node, _ctx=nil)
		NodeObserver_mixin::OP_nodeUp.invoke(self, [node], _ctx)
	    end

	    def nodeDown(name, _ctx=nil)
		NodeObserver_mixin::OP_nodeDown.invoke(self, [name], _ctx)
	    end

	    def updateServer(node, updatedInfo, _ctx=nil)
		NodeObserver_mixin::OP_updateServer.invoke(self, [node, updatedInfo], _ctx)
	    end

	    def updateAdapter(node, updatedInfo, _ctx=nil)
		NodeObserver_mixin::OP_updateAdapter.invoke(self, [node, updatedInfo], _ctx)
	    end
	end
	class NodeObserverPrx < ::Ice::ObjectPrx
	    include NodeObserverPrx_mixin

	    def NodeObserverPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
		ice_checkedCast(proxy, '::IceGrid::NodeObserver', facetOrCtx, _ctx)
	    end

	    def NodeObserverPrx.uncheckedCast(proxy, facet='')
		ice_uncheckedCast(proxy, facet)
	    end
	end

	if not defined?(::IceGrid::T_NodeObserver)
	    T_NodeObserver = ::Ice::__declareClass('::IceGrid::NodeObserver')
	    T_NodeObserverPrx = ::Ice::__declareProxy('::IceGrid::NodeObserver')
	end

	T_NodeObserver.defineClass(nil, true, nil, [], [])
	NodeObserver_mixin::ICE_TYPE = T_NodeObserver

	T_NodeObserverPrx.defineProxy(NodeObserverPrx, T_NodeObserver)
	NodeObserverPrx::ICE_TYPE = T_NodeObserverPrx

	NodeObserver_mixin::OP_init = ::Ice::__defineOperation('init', ::Ice::OperationMode::Normal, false, [::IceGrid::T_NodeDynamicInfoSeq], [], nil, [])
	NodeObserver_mixin::OP_nodeUp = ::Ice::__defineOperation('nodeUp', ::Ice::OperationMode::Normal, false, [::IceGrid::T_NodeDynamicInfo], [], nil, [])
	NodeObserver_mixin::OP_nodeDown = ::Ice::__defineOperation('nodeDown', ::Ice::OperationMode::Normal, false, [::Ice::T_string], [], nil, [])
	NodeObserver_mixin::OP_updateServer = ::Ice::__defineOperation('updateServer', ::Ice::OperationMode::Normal, false, [::Ice::T_string, ::IceGrid::T_ServerDynamicInfo], [], nil, [])
	NodeObserver_mixin::OP_updateAdapter = ::Ice::__defineOperation('updateAdapter', ::Ice::OperationMode::Normal, false, [::Ice::T_string, ::IceGrid::T_AdapterDynamicInfo], [], nil, [])
    end

    if not defined?(::IceGrid::RegistryObserver_mixin)
	module RegistryObserver_mixin
	    include ::Ice::Object_mixin

	    def ice_ids(current=nil)
		['::Ice::Object', '::IceGrid::RegistryObserver']
	    end

	    def ice_id(current=nil)
		'::IceGrid::RegistryObserver'
	    end

	    #
	    # Operation signatures.
	    #
	    # def init(serial, applications, adpts, objects, current=nil)
	    # def applicationAdded(serial, desc, current=nil)
	    # def applicationRemoved(serial, name, current=nil)
	    # def applicationUpdated(serial, desc, current=nil)
	    # def adapterAdded(serial, info, current=nil)
	    # def adapterUpdated(serial, info, current=nil)
	    # def adapterRemoved(serial, id, current=nil)
	    # def objectAdded(serial, info, current=nil)
	    # def objectUpdated(serial, info, current=nil)
	    # def objectRemoved(serial, id, current=nil)

	    def inspect
		::Ice::__stringify(self, T_RegistryObserver)
	    end
	end
	module RegistryObserverPrx_mixin

	    def init(serial, applications, adpts, objects, _ctx=nil)
		RegistryObserver_mixin::OP_init.invoke(self, [serial, applications, adpts, objects], _ctx)
	    end

	    def init_async(_cb, serial, applications, adpts, objects, _ctx=nil)
		RegistryObserver_mixin::OP_init.invokeAsync(self, _cb, [serial, applications, adpts, objects], _ctx)
	    end

	    def applicationAdded(serial, desc, _ctx=nil)
		RegistryObserver_mixin::OP_applicationAdded.invoke(self, [serial, desc], _ctx)
	    end

	    def applicationRemoved(serial, name, _ctx=nil)
		RegistryObserver_mixin::OP_applicationRemoved.invoke(self, [serial, name], _ctx)
	    end

	    def applicationUpdated(serial, desc, _ctx=nil)
		RegistryObserver_mixin::OP_applicationUpdated.invoke(self, [serial, desc], _ctx)
	    end

	    def adapterAdded(serial, info, _ctx=nil)
		RegistryObserver_mixin::OP_adapterAdded.invoke(self, [serial, info], _ctx)
	    end

	    def adapterUpdated(serial, info, _ctx=nil)
		RegistryObserver_mixin::OP_adapterUpdated.invoke(self, [serial, info], _ctx)
	    end

	    def adapterRemoved(serial, id, _ctx=nil)
		RegistryObserver_mixin::OP_adapterRemoved.invoke(self, [serial, id], _ctx)
	    end

	    def objectAdded(serial, info, _ctx=nil)
		RegistryObserver_mixin::OP_objectAdded.invoke(self, [serial, info], _ctx)
	    end

	    def objectUpdated(serial, info, _ctx=nil)
		RegistryObserver_mixin::OP_objectUpdated.invoke(self, [serial, info], _ctx)
	    end

	    def objectRemoved(serial, id, _ctx=nil)
		RegistryObserver_mixin::OP_objectRemoved.invoke(self, [serial, id], _ctx)
	    end
	end
	class RegistryObserverPrx < ::Ice::ObjectPrx
	    include RegistryObserverPrx_mixin

	    def RegistryObserverPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
		ice_checkedCast(proxy, '::IceGrid::RegistryObserver', facetOrCtx, _ctx)
	    end

	    def RegistryObserverPrx.uncheckedCast(proxy, facet='')
		ice_uncheckedCast(proxy, facet)
	    end
	end

	if not defined?(::IceGrid::T_RegistryObserver)
	    T_RegistryObserver = ::Ice::__declareClass('::IceGrid::RegistryObserver')
	    T_RegistryObserverPrx = ::Ice::__declareProxy('::IceGrid::RegistryObserver')
	end

	T_RegistryObserver.defineClass(nil, true, nil, [], [])
	RegistryObserver_mixin::ICE_TYPE = T_RegistryObserver

	T_RegistryObserverPrx.defineProxy(RegistryObserverPrx, T_RegistryObserver)
	RegistryObserverPrx::ICE_TYPE = T_RegistryObserverPrx

	RegistryObserver_mixin::OP_init = ::Ice::__defineOperation('init', ::Ice::OperationMode::Normal, false, [::Ice::T_int, ::IceGrid::T_ApplicationDescriptorSeq, ::IceGrid::T_AdapterInfoSeq, ::IceGrid::T_ObjectInfoSeq], [], nil, [])
	RegistryObserver_mixin::OP_applicationAdded = ::Ice::__defineOperation('applicationAdded', ::Ice::OperationMode::Normal, false, [::Ice::T_int, ::IceGrid::T_ApplicationDescriptor], [], nil, [])
	RegistryObserver_mixin::OP_applicationRemoved = ::Ice::__defineOperation('applicationRemoved', ::Ice::OperationMode::Normal, false, [::Ice::T_int, ::Ice::T_string], [], nil, [])
	RegistryObserver_mixin::OP_applicationUpdated = ::Ice::__defineOperation('applicationUpdated', ::Ice::OperationMode::Normal, false, [::Ice::T_int, ::IceGrid::T_ApplicationUpdateDescriptor], [], nil, [])
	RegistryObserver_mixin::OP_adapterAdded = ::Ice::__defineOperation('adapterAdded', ::Ice::OperationMode::Normal, false, [::Ice::T_int, ::IceGrid::T_AdapterInfo], [], nil, [])
	RegistryObserver_mixin::OP_adapterUpdated = ::Ice::__defineOperation('adapterUpdated', ::Ice::OperationMode::Normal, false, [::Ice::T_int, ::IceGrid::T_AdapterInfo], [], nil, [])
	RegistryObserver_mixin::OP_adapterRemoved = ::Ice::__defineOperation('adapterRemoved', ::Ice::OperationMode::Normal, false, [::Ice::T_int, ::Ice::T_string], [], nil, [])
	RegistryObserver_mixin::OP_objectAdded = ::Ice::__defineOperation('objectAdded', ::Ice::OperationMode::Normal, false, [::Ice::T_int, ::IceGrid::T_ObjectInfo], [], nil, [])
	RegistryObserver_mixin::OP_objectUpdated = ::Ice::__defineOperation('objectUpdated', ::Ice::OperationMode::Normal, false, [::Ice::T_int, ::IceGrid::T_ObjectInfo], [], nil, [])
	RegistryObserver_mixin::OP_objectRemoved = ::Ice::__defineOperation('objectRemoved', ::Ice::OperationMode::Normal, false, [::Ice::T_int, ::Ice::T_Identity], [], nil, [])
    end
end
